/*
 * Algoritmo: Ejemplo de mezcla de estructuras de control. Buscar los
 * elementos repetidos en un vector.
 * Autor: Antonio Vlez Estvez
 * Fecha: 30/06/2016
 */
 
Algoritmo EstructurasControlMezcla03

//Seccin de definicin de variables constantes
const 
	MAX = 30
//Seccin de definicion de tipos
tipo
	vector [MAX] de entero: Vector
//Seccin de declaracin de variables globales	
var

//Seccin de definicin de subalgoritmos: funciones y procedimientos	

//Comienzo del algoritmo (Obligatorio)
principal	
	var
	// Variable de control del primer bucle.
	entero: i
	// Variable de control del segundo bucle.
	entero: j
	// Vector de elementos donde tenemos que mirar si estn repetidos.
	Vector: elementos
	// Ultimo indice usado para el vector de los elementos que ya se han mirado
	entero: indice
	// Ya contados.
	Vector: repetidos
	logico : repetido
	logico : encontrado
inicio 	

	encontrado <- falso
	// En principio el vector no contiene ningun elemento asi que el indice estara en -1.
	indice <-  -1
	
	/* Inicializamos el vector de elementos con una sucesin sin elementos repe
	 * tidos es decir, 1, 2, 3, ..., i. Para comprobar que funciona bien la bus
	 * queda de elementos repetidos podemos probar con i mod n, siendo n cualquier
	 * numero.
	 */ 
	desde i <- 0 hasta MAX - 1 hacer
		elementos[i] <- i
	fin_desde
	
	
	// Vamos tomando cada elemento del vector (establecemos un pivote en cada u
	// no de los elementos).
	desde i <- 0 hasta MAX - 1 hacer
	
		j <- 0
		encontrado <- falso
		
		/*
		 * Aqui comprobamos si el elemento en el que hemos establecido el pivot
		 * e se ha establecido ya como repetido o no, para no volverlo a poner
		 * mas veces.
		 */
		mientras (j <= indice y no encontrado) hacer
			si (elementos[i] = repetidos[j]) entonces
				encontrado <- verdadero
			fin_si
			j <- j + 1
		fin_mientras	
		
		// Si no esta, pues miramos si esta repetido
		si (encontrado = falso) entonces
			/* 
			 * Comenzamos por una posicion posterior a la del elemento que toma
			 * mos como pivote, ya que si hubiese habido un elemento igual antes
			 * de este, ya estaria en el vector de contados y no haria falta vol
			 * ver a mirar si esta repetido.
			 */
			j <- i + 1
			repetido <- falso
			
			mientras (j != MAX y no repetido) hacer
				/* 
				 * Si esta repetido, ponemos la variable repetido a verdadero y
				 * aadimos dicho elemento al vector de elementos contados. Ade
				 * mas incrementamos el indice, es importante incrementar prime
				 * ro y luego asignar en este caso, ya que en principio el indi
				 * ce esta a -1 y es es un indice no valido.
				 */
				si(elementos[i] = elementos[j]) entonces
					repetido <- verdadero
					indice <- indice + 1
					repetidos[indice] <- elementos[i]
				fin_si
				
				j <- j + 1
				
			fin_mientras
		fin_si
	fin_desde
	
	// Con el siguiente bucle mostraremos los elementos repetidos, que estan almacenados
	// en el vector "contados" hasta la posicion indice.
	
	escribir("Los elementos repetidos son:")
	desde i <- 0 hasta indice hacer
		escribir(repetidos[i], ", " )
	fin_desde

fin_principal
fin_algoritmo